## trace-cmd 1.0.3

=== Makefile ===
# trace-cmd version
TC_VERSION = 1
TC_PATCHLEVEL = 0
TC_EXTRAVERSION = 3

# Kernel Shark version
KS_VERSION = 0
KS_PATCHLEVEL = 2
KS_EXTRAVERSION =

# file format version
FILE_VERSION = 6

MAKEFLAGS += --no-print-directory

CC = $(CROSS_COMPILE)gcc
AR = $(CROSS_COMPILE)ar
EXT = -std=gnu99
INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

prefix ?= /usr/local
bindir_relative = bin
bindir = $(prefix)/$(bindir_relative)
man_dir = $(prefix)/share/man
man_dir_SQ = '$(subst ','\'',$(man_dir))'

export man_dir man_dir_SQ INSTALL
export DESTDIR DESTDIR_SQ

ifeq ($(prefix),$(HOME))
plugin_dir = $(HOME)/.trace-cmd/plugins
else
plugin_dir = $(prefix)/share/trace-cmd/plugins
PLUGIN_DIR = -DPLUGIN_DIR=$(plugin_dir)
PLUGIN_DIR_SQ = '$(subst ','\'',$(PLUGIN_DIR))'
endif

# copy a bit from Linux kbuild

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

ifeq ("$(origin O)", "command line")
  BUILD_OUTPUT := $(O)
endif

ifeq ($(BUILD_SRC),)
ifneq ($(BUILD_OUTPUT),)

define build_output
	$(if $(VERBOSE:1=),@)$(MAKE) -C $(BUILD_OUTPUT) 	\
	BUILD_SRC=$(CURDIR) -f $(CURDIR)/Makefile $1
endef

saved-output := $(BUILD_OUTPUT)
BUILD_OUTPUT := $(shell cd $(BUILD_OUTPUT) && /bin/pwd)
$(if $(BUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

all: sub-make

gui: force
	$(call build_output, all_cmd)
	$(call build_output, BUILDGUI=1 all_gui)

$(filter-out gui,$(MAKECMDGOALS)): sub-make

sub-make: force
	$(call build_output, $(MAKECMDGOALS))


# Leave processing to above invocation of make
skip-makefile := 1

endif # BUILD_OUTPUT
endif # BUILD_SRC

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

srctree		:= $(if $(BUILD_SRC),$(BUILD_SRC),$(CURDIR))
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

export prefix bindir src obj

# Shell quotes
bindir_SQ = $(subst ','\'',$(bindir))
bindir_relative_SQ = $(subst ','\'',$(bindir_relative))
plugin_dir_SQ = $(subst ','\'',$(plugin_dir))

LIBS = -L. -ltracecmd -ldl
LIB_FILE = libtracecmd.a

PACKAGES= gtk+-2.0

ifndef BUILDGUI
 BUILDGUI = 0
endif

ifeq ($(BUILDGUI), 1)

CONFIG_INCLUDES = $(shell pkg-config --cflags $(PACKAGES)) -I$(obj)

CONFIG_FLAGS = -DBUILDGUI \
	-DGTK_VERSION=$(shell pkg-config --modversion gtk+-2.0 | \
	awk 'BEGIN{FS="."}{ a = ($$1 * (2^16)) + $$2 * (2^8) + $$3; printf ("%d", a);}')

CONFIG_LIBS = $(shell pkg-config --libs $(PACKAGES))

VERSION		= $(KS_VERSION)
PATCHLEVEL	= $(KS_PATCHLEVEL)
EXTRAVERSION	= $(KS_EXTRAVERSION)

GUI		= 'GUI '
GOBJ		= $@
GSPACE		=

REBUILD_GUI	= /bin/true
G		=
N 		= @/bin/true ||

else

CONFIG_INCLUDES = 
CONFIG_LIBS	=
CONFIG_FLAGS	=

VERSION		= $(TC_VERSION)
PATCHLEVEL	= $(TC_PATCHLEVEL)
EXTRAVERSION	= $(TC_EXTRAVERSION)

GUI		=
GSPACE		= "    "
GOBJ		= $(GSPACE)$@

REBUILD_GUI	= $(MAKE) -f $(src)/Makefile BUILDGUI=1 $@
G		= $(REBUILD_GUI); /bin/true ||
N		=
endif

export Q VERBOSE

TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
KERNELSHARK_VERSION = $(KS_VERSION).$(KS_PATCHLEVEL).$(KS_EXTRAVERSION)

INCLUDES = -I. -I/usr/local/include $(CONFIG_INCLUDES)

CFLAGS = -g -Wall $(CONFIG_FLAGS) $(INCLUDES) $(PLUGIN_DIR_SQ)

ifeq ($(VERBOSE),1)
  Q =
  print_compile =
  print_app_build =
  print_fpic_compile =
  print_shared_lib_compile =
  print_plugin_obj_compile =
  print_plugin_build =
  print_install =
else
  Q = @
  print_compile =		echo '  $(GUI)COMPILE            '$(GOBJ);
  print_app_build =		echo '  $(GUI)BUILD              '$(GOBJ);
  print_fpic_compile =		echo '  $(GUI)COMPILE FPIC       '$(GOBJ);
  print_shared_lib_compile =	echo '  $(GUI)COMPILE SHARED LIB '$(GOBJ);
  print_plugin_obj_compile =	echo '  $(GUI)COMPILE PLUGIN OBJ '$(GOBJ);
  print_plugin_build =		echo '  $(GUI)BUILD PLUGIN       '$(GOBJ);
  print_static_lib_build =	echo '  $(GUI)BUILD STATIC LIB   '$(GOBJ);
  print_install =		echo '  $(GUI)INSTALL     '$(GSPACE)$1'	to	$(DESTDIR_SQ)$2';
endif

do_fpic_compile =					\
	($(print_fpic_compile)				\
	$(CC) -c $(CFLAGS) $(EXT) -fPIC $< -o $@)

do_app_build =						\
	($(print_app_build)				\
	$(CC) $^ -rdynamic -o $@ $(CONFIG_LIBS) $(LIBS))

do_compile_shared_library =			\
	($(print_shared_lib_compile)		\
	$(CC) --shared $^ -o $@)

do_compile_plugin_obj =				\
	($(print_plugin_obj_compile)		\
	$(CC) -c $(CFLAGS) -fPIC -o $@ $<)

do_plugin_build =				\
	($(print_plugin_build)			\
	$(CC) -shared -nostartfiles -o $@ $<)

do_build_static_lib =				\
	($(print_static_lib_build)		\
	$(RM) $@;  $(AR) rcs $@ $^)


define check_gui
	if [ $(BUILDGUI) -ne 1 -a ! -z "$(filter $(gui_objs),$(@))" ];	then	\
		$(REBUILD_GUI);							\
	else									\
		$(print_compile)						\
		$(CC) -c $(CFLAGS) $(EXT) $< -o $(obj)/$@;			\
	fi;
endef

$(obj)/%.o: $(src)/%.c
	$(Q)$(call check_gui)

%.o: $(src)/%.c
	$(Q)$(call check_gui)

TRACE_CMD_OBJS = trace-cmd.o trace-usage.o trace-read.o trace-split.o trace-listen.o
TRACE_VIEW_OBJS = trace-view.o trace-view-store.o trace-filter.o trace-compat.o \
	trace-hash.o
TRACE_GRAPH_OBJS = trace-graph.o trace-compat.o trace-hash.o trace-filter.o \
		trace-plot.o trace-plot-cpu.o trace-plot-task.o
TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS)
TRACE_GRAPH_MAIN_OBJS = trace-graph-main.o $(TRACE_GRAPH_OBJS)
KERNEL_SHARK_OBJS = $(TRACE_VIEW_OBJS) $(TRACE_GRAPH_OBJS) kernel-shark.o

PEVENT_LIB_OBJS = parse-events.o trace-seq.o parse-filter.o
TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
			trace-output.o trace-record.o

PLUGIN_OBJS = plugin_hrtimer.o plugin_kmem.o plugin_sched_switch.o \
	plugin_mac80211.o plugin_jbd2.o

PLUGINS := $(PLUGIN_OBJS:.o=.so)

ALL_OBJS = $(TRACE_CMD_OBJS) $(KERNEL_SHARK_OBJS) $(TRACE_VIEW_MAIN_OBJS) \
	$(TRACE_GRAPH_MAIN_OBJS) $(TCMD_LIB_OBJS) $(PLUGIN_OBJS)

CMD_TARGETS = trace_plugin_dir tc_version.h libparsevent.a $(LIB_FILE) trace-cmd  $(PLUGINS)

GUI_TARGETS = ks_version.h trace-graph trace-view kernelshark

TARGETS = $(CMD_TARGETS) $(GUI_TARGETS)


#	cpp $(INCLUDES)

###
#    Default we just build trace-cmd
#
#    If you want kernelshark, then do:  make gui
###

all: all_cmd show_gui_make

all_cmd: $(CMD_TARGETS)

gui: $(CMD_TARGETS)
	$(Q)$(MAKE) -f $(src)/Makefile BUILDGUI=1 all_gui

all_gui: $(GUI_TARGETS) show_gui_done

GUI_OBJS = $(KERNEL_SHARK_OBJS) $(TRACE_VIEW_MAIN_OBJS) $(TRACE_GRAPH_MAIN_OBJS)

gui_objs := $(sort $(GUI_OBJS))

trace-cmd: $(TRACE_CMD_OBJS)
	$(Q)$(do_app_build)

kernelshark: $(KERNEL_SHARK_OBJS)
	$(Q)$(G)$(do_app_build)

trace-view: $(TRACE_VIEW_MAIN_OBJS)
	$(Q)$(G)$(do_app_build)

trace-graph: $(TRACE_GRAPH_MAIN_OBJS)
	$(Q)$(G)$(do_app_build)

trace-cmd: libtracecmd.a
kernelshark: libtracecmd.a
trace-view: libtracecmd.a
trace-graph: libtracecmd.a

libparsevent.so: $(PEVENT_LIB_OBJS)
	$(Q)$(do_compile_shared_library)

libparsevent.a: $(PEVENT_LIB_OBJS)
	$(Q)$(do_build_static_lib)

$(TCMD_LIB_OBJS): %.o: $(src)/%.c
	$(Q)$(do_fpic_compile)

libtracecmd.so: $(TCMD_LIB_OBJS)
	$(Q)$(do_compile_shared_library)

libtracecmd.a: $(TCMD_LIB_OBJS)
	$(Q)$(do_build_static_lib)

trace-util.o: trace_plugin_dir

$(PLUGIN_OBJS): %.o : $(src)/%.c
	$(Q)$(do_compile_plugin_obj)

$(PLUGINS): %.so: %.o
	$(Q)$(do_plugin_build)

define make_version.h
	(echo '/* This file is automatically generated. Do not modify. */';		\
	echo \#define VERSION_CODE $(shell						\
	expr $(VERSION) \* 256 + $(PATCHLEVEL));					\
	echo '#define EXTRAVERSION ' $(EXTRAVERSION);					\
	echo '#define VERSION_STRING "'$(VERSION).$(PATCHLEVEL).$(EXTRAVERSION)'"';	\
	echo '#define FILE_VERSION '$(FILE_VERSION);					\
	) > $1
endef

define update_version.h
	($(call make_version.h, $@.tmp);		\
	if [ -r $@ ] && cmp -s $@ $@.tmp; then		\
		rm -f $@.tmp;				\
	else						\
		echo '  UPDATE                 $@';	\
		mv -f $@.tmp $@;			\
	fi);
endef

ks_version.h: force
	$(Q)$(G)$(call update_version.h)

tc_version.h: force
	$(Q)$(N)$(call update_version.h)

define update_plugin_dir
	(echo 'PLUGIN_DIR=$(PLUGIN_DIR)' > $@.tmp;	\
	if [ -r $@ ] && cmp -s $@ $@.tmp; then		\
		rm -f $@.tmp;				\
	else						\
		echo '  UPDATE                 $@';	\
		mv -f $@.tmp $@;			\
	fi);
endef

trace_plugin_dir: force
	$(Q)$(N)$(call update_plugin_dir)

## make deps

all_objs := $(sort $(ALL_OBJS))
all_deps := $(all_objs:%.o=.%.d)
gui_deps := $(gui_objs:%.o=.%.d)
non_gui_deps = $(filter-out $(gui_deps),$(all_deps))

define check_gui_deps
	if [ ! -z "$(filter $(gui_deps),$(@))" ];	then	\
		if [ $(BUILDGUI) -ne 1 ]; then			\
			$(REBUILD_GUI);				\
		else						\
			$(CC) -M $(CFLAGS) $< > $@;		\
		fi						\
	elif [ $(BUILDGUI) -eq 0 ]; then			\
		$(CC) -M $(CFLAGS) $< > $@;			\
	else							\
		echo SKIPPING $@;				\
	fi;
endef

$(gui_deps): ks_version.h
$(non_gui_deps): tc_version.h

$(all_deps): .%.d: $(src)/%.c
	$(Q)$(call check_gui_deps)

$(all_objs) : %.o : .%.d

ifeq ($(BUILDGUI), 1)
dep_includes := $(wildcard $(gui_deps))
else
dep_includes := $(wildcard $(non_gui_deps))
endif

ifneq ($(dep_includes),)
 include $(dep_includes)
endif

show_gui_make:
	@echo "Note: to build the gui, type \"make gui\""

show_gui_done:
	@echo "gui build complete"

PHONY += show_gui_make

tags:	force
	$(RM) tags
	find . -name '*.[ch]' | xargs ctags

TAGS:	force
	$(RM) TAGS
	find . -name '*.[ch]' | xargs etags

PLUGINS_INSTALL = $(subst .so,.install,$(PLUGINS))

define do_install
	$(print_install)				\
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
	fi;						\
	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
endef

$(PLUGINS_INSTALL): %.install : %.so force
	$(Q)$(call do_install,$<,$(plugin_dir_SQ))

install_plugins: $(PLUGINS_INSTALL)

install_cmd: all_cmd install_plugins
	$(Q)$(call do_install,trace-cmd,$(bindir_SQ))

install: install_cmd
	@echo "Note: to install the gui, type \"make install_gui\""

install_gui: install_cmd gui
	$(Q)$(call do_install,trace-view,$(bindir_SQ))
	$(Q)$(call do_install,trace-graph,$(bindir_SQ))
	$(Q)$(call do_install,kernelshark,$(bindir_SQ))

doc:
	$(MAKE) -C $(src)/Documentation all

doc_clean:
	$(MAKE) -C $(src)/Documentation clean

install_doc:
	$(MAKE) -C $(src)/Documentation install

clean:
	$(RM) *.o *~ $(TARGETS) *.a *.so ctracecmd_wrap.c .*.d
	$(RM) tags TAGS trace_plugin_dir


##### PYTHON STUFF #####

PYTHON_INCLUDES = `python-config --includes`
PYGTK_CFLAGS = `pkg-config --cflags pygtk-2.0`

ctracecmd.so: $(TCMD_LIB_OBJS)
	swig -Wall -python -noproxy ctracecmd.i
	gcc -fpic -c $(PYTHON_INCLUDES)  ctracecmd_wrap.c
	$(CC) --shared $^ ctracecmd_wrap.o -o ctracecmd.so

ctracecmdgui.so: $(TRACE_VIEW_OBJS) $(LIB_FILE)
	swig -Wall -python -noproxy ctracecmdgui.i
	gcc -fpic -c  $(CFLAGS) $(INCLUDES) $(PYTHON_INCLUDES) $(PYGTK_CFLAGS) ctracecmdgui_wrap.c
	$(CC) --shared $^ $(LIBS) $(CONFIG_LIBS) ctracecmdgui_wrap.o -o ctracecmdgui.so

PHONY += python
python: ctracecmd.so

PHONY += python-gui
python-gui: ctracecmd.so ctracecmdgui.so 

endif # skip-makefile

PHONY += force
force:

# Declare the contents of the .PHONY variable as phony.  We keep that
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)

=== Documentation/Makefile ===

obj := $(obj)/Documentation
src := $(src)/Documentation

ifeq ($(VERBOSE),1)
  Q =
  print_asciidoc =
  print_xsltproc =
  print_install =
  hide_xsltproc_output =
else
  Q = @
  print_asciidoc =		echo '      ASCIIDOC            '`basename $@`;
  print_xsltproc =		echo '      XSLTPROC            '`basename $@`;
  print_install =		echo '      INSTALL             '`basename $1`'	to	$(DESTDIR_SQ)'$2;
  hide_xsltproc_output = 2> /dev/null
endif

define manpage.xsl
	if [ ! -f ${MANPAGE_DOCBOOK_XSL} ]; then 		\
		echo "*********************************";	\
		echo "** No docbook.xsl is installed **";	\
		echo "** Can't make man pages        **";	\
		echo "*********************************";	\
		exit 1;						\
	fi
endef

do_asciidoc_build =				\
	($(print_asciidoc)			\
	 asciidoc -d manpage -b docbook -o $@ $<)

do_xsltproc_build =				\
	($(print_xsltproc)			\
	 xsltproc --nonet -o $@ ${MANPAGE_DOCBOOK_XSL} $< $(hide_xsltproc_output))

#
# asciidoc requires a synopsis, but file format man pages (5) do
# not require them. This removes it from the file in the final step.
define remove_synopsis
	(sed -e '/^\.SH "SYNOPSIS"/,/ignore/d' $1 > $1.tmp;\
	 mv $1.tmp $1)
endef

#
# Most likely a docbook.xsl is already installed on the users system
# instead of creating a new wheel, lets reuse what's already there.
#
MANPAGE_DOCBOOK_XSL =  $(shell locate manpages/docbook.xsl | head -1)

$(obj)/%.xsl: $(src)/%.txt
	$(Q)mkdir -p $(obj)
	$(Q)$(do_asciidoc_build)


$(obj)/%.1: $(obj)/%.1.xsl
	@$(call manpage.xsl)
	$(Q)$(do_xsltproc_build)

$(obj)/%.5: $(obj)/%.5.xsl
	@$(call manpage.xsl)
	$(Q)$(do_xsltproc_build)
	$(Q)$(call remove_synopsis, $@)

TEXT1 = $(wildcard *.1.txt)
MAN1 = $(patsubst %.1.txt,$(obj)/%.1, ${TEXT1})
TEXT5 = $(wildcard *.5.txt)
MAN5 = $(patsubst %.5.txt,$(obj)/%.5, ${TEXT5})

all: $(MAN1) $(MAN5)

# Need to find out how to export a macro instead of
# copying this from the main Makefile.
define do_install
	$(print_install)				\
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
	fi;						\
	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
endef

MAN1_INSTALL = $(MAN1:%.1=%.1.install)
MAN5_INSTALL = $(MAN5:%.5=%.5.install)

$(MAN1_INSTALL): %.1.install : %.1 force
	$(Q)$(call do_install,$<,$(man_dir_SQ)/man1)
$(MAN5_INSTALL): %.5.install : %.5 force
	$(Q)$(call do_install,$<,$(man_dir_SQ)/man5)

install: $(MAN1_INSTALL) $(MAN5_INSTALL)

clean:
	(cd $(obj); \
	 $(RM) *.xml *.xsl *.1 *.5)

.PHONE: force
force:

=== debian/changelog ===
trace-cmd (1.0.3-0ubuntu1) maverick; urgency=low

  * Initial release.
    - LP: #593343

 -- Chase Douglas <chase.douglas@canonical.com>  Thu, 10 Jun 2010 14:59:05 -0400

=== debian/control ===
Source: trace-cmd
Section: devel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
Standards-Version: 3.8.4.0
Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc
Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git

Package: trace-cmd
Architecture: any
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: kernelshark
Description: Utility for retrieving and analyzing function tracing in the kernel
 This package contains the trace-cmd utility. Trace-cmd makes it easy to
 retrieve and analyze function traces from the Linux kernel while it is running.

Package: kernelshark
Architecture: any
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: trace-cmd
Description: Utilities for graphically analyzing function tracing in the kernel
 This package contains the kernelshark, trace-view, and trace-graph programs.
 Data for analysis may be generated by the trace-cmd utility.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

OPTS=prefix=/usr plugin_dir=/usr/lib/trace-cmd/plugins MANPAGE_DOCBOOK_XSL=/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl DESTDIR=$(DEB_DESTDIR) V=1

DEB_MAKE_CLEAN_TARGET=clean doc_clean $(OPTS)
DEB_MAKE_BUILD_TARGET=gui doc $(OPTS)
DEB_MAKE_INSTALL_TARGET=install_gui install_doc $(OPTS)

## trace-cmd 2.2.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
-TC_VERSION = 1
-TC_PATCHLEVEL = 0
-TC_EXTRAVERSION = 3
+TC_VERSION = 2
+TC_PATCHLEVEL = 2
+TC_EXTRAVERSION = 1
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -13,8 +13,21 @@
 
 MAKEFLAGS += --no-print-directory
 
-CC = $(CROSS_COMPILE)gcc
-AR = $(CROSS_COMPILE)ar
+# Makefiles suck: This macro sets a default value of $(2) for the
+# variable named by $(1), unless the variable has been set by
+# environment or command line. This is necessary for CC and AR
+# because make sets default values, so the simpler ?= approach
+# won't work as expected.
+define allow-override
+  $(if $(or $(findstring environment,$(origin $(1))),\
+            $(findstring command line,$(origin $(1)))),,\
+    $(eval $(1) = $(2)))
+endef
+
+# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
+$(call allow-override,CC,$(CROSS_COMPILE)gcc)
+$(call allow-override,AR,$(CROSS_COMPILE)ar)
+
 EXT = -std=gnu99
 INSTALL = install
 
@@ -30,17 +43,29 @@
 bindir = $(prefix)/$(bindir_relative)
 man_dir = $(prefix)/share/man
 man_dir_SQ = '$(subst ','\'',$(man_dir))'
-
-export man_dir man_dir_SQ INSTALL
+html_install = $(prefix)/share/kernelshark/html
+html_install_SQ = '$(subst ','\'',$(html_install))'
+img_install = $(prefix)/share/kernelshark/html/images
+img_install_SQ = '$(subst ','\'',$(img_install))'
+
+export man_dir man_dir_SQ html_install html_install_SQ INSTALL
+export img_install img_install_SQ
 export DESTDIR DESTDIR_SQ
 
 ifeq ($(prefix),$(HOME))
 plugin_dir = $(HOME)/.trace-cmd/plugins
+python_dir = $(HOME)/.trace-cmd/python
 else
-plugin_dir = $(prefix)/share/trace-cmd/plugins
-PLUGIN_DIR = -DPLUGIN_DIR=$(plugin_dir)
+plugin_dir = $(prefix)/lib/trace-cmd/plugins
+python_dir = $(prefix)/lib/trace-cmd/python
+PLUGIN_DIR = -DPLUGIN_DIR="$(plugin_dir)"
+PYTHON_DIR = -DPYTHON_DIR="$(python_dir)"
 PLUGIN_DIR_SQ = '$(subst ','\'',$(PLUGIN_DIR))'
-endif
+PYTHON_DIR_SQ = '$(subst ','\'',$(PYTHON_DIR))'
+endif
+
+HELP_DIR = -DHELP_DIR=$(html_install)
+HELP_DIR_SQ = '$(subst ','\'',$(HELP_DIR))'
 
 # copy a bit from Linux kbuild
 
@@ -50,6 +75,35 @@
 ifndef VERBOSE
   VERBOSE = 0
 endif
+
+ifndef NO_PYTHON
+PYTHON		:= ctracecmd.so
+PYTHON_GUI	:= ctracecmd.so ctracecmdgui.so
+
+# Can build python?
+ifeq ($(shell sh -c "python-config --includes > /dev/null 2>&1 && echo y"), y)
+	PYTHON_PLUGINS := plugin_python.so
+	BUILD_PYTHON := $(PYTHON) $(PYTHON_PLUGINS)
+	PYTHON_SO_INSTALL := ctracecmd.install
+	PYTHON_PY_INSTALL := event-viewer.install tracecmd.install tracecmdgui.install
+endif
+endif # NO_PYTHON
+
+# $(call test-build, snippet, ret) -> ret if snippet compiles
+#                                  -> empty otherwise
+test-build = $(if $(shell sh -c 'echo "$(1)" | \
+	$(CC) -o /dev/null -c -x c - > /dev/null 2>&1 && echo y'), $2)
+
+# have udis86 disassembler library?
+udis86-flags := $(call test-build,\#include <udis86.h>,-DHAVE_UDIS86 -ludis86)
+
+define BLK_TC_FLUSH_SOURCE
+#include <linux/blktrace_api.h>
+int main(void) { return BLK_TC_FLUSH; }
+endef
+
+# have flush/fua block layer instead of barriers?
+blk-flags := $(call test-build,$(BLK_TC_FLUSH_SOURCE),-DHAVE_BLK_TC_FLUSH)
 
 ifeq ("$(origin O)", "command line")
   BUILD_OUTPUT := $(O)
@@ -100,11 +154,12 @@
 bindir_SQ = $(subst ','\'',$(bindir))
 bindir_relative_SQ = $(subst ','\'',$(bindir_relative))
 plugin_dir_SQ = $(subst ','\'',$(plugin_dir))
+python_dir_SQ = $(subst ','\'',$(python_dir))
 
 LIBS = -L. -ltracecmd -ldl
 LIB_FILE = libtracecmd.a
 
-PACKAGES= gtk+-2.0
+PACKAGES= gtk+-2.0 libxml-2.0 gthread-2.0
 
 ifndef BUILDGUI
  BUILDGUI = 0
@@ -132,6 +187,7 @@
 G		=
 N 		= @/bin/true ||
 
+CONFIG_FLAGS	+= $(HELP_DIR_SQ)
 else
 
 CONFIG_INCLUDES = 
@@ -156,9 +212,28 @@
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 KERNELSHARK_VERSION = $(KS_VERSION).$(KS_PATCHLEVEL).$(KS_EXTRAVERSION)
 
-INCLUDES = -I. -I/usr/local/include $(CONFIG_INCLUDES)
-
-CFLAGS = -g -Wall $(CONFIG_FLAGS) $(INCLUDES) $(PLUGIN_DIR_SQ)
+INCLUDES = -I. $(CONFIG_INCLUDES)
+
+include features.mk
+
+# Set compile option CFLAGS if not set elsewhere
+CFLAGS ?= -g -Wall -D_GNU_SOURCE
+LDFLAGS ?=
+
+ifndef NO_PTRACE
+ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
+	NO_PTRACE = 1
+	CFLAGS += -DWARN_NO_PTRACE
+endif
+endif
+
+ifdef NO_PTRACE
+CFLAGS += -DNO_PTRACE
+endif
+
+# Append required CFLAGS
+override CFLAGS += $(CONFIG_FLAGS) $(INCLUDES) $(PLUGIN_DIR_SQ)
+override CFLAGS += $(udis86-flags) $(blk-flags)
 
 ifeq ($(VERBOSE),1)
   Q =
@@ -187,7 +262,7 @@
 
 do_app_build =						\
 	($(print_app_build)				\
-	$(CC) $^ -rdynamic -o $@ $(CONFIG_LIBS) $(LIBS))
+	$(CC) $^ -rdynamic -o $@ $(LDFLAGS) $(CONFIG_LIBS) $(LIBS))
 
 do_compile_shared_library =			\
 	($(print_shared_lib_compile)		\
@@ -199,7 +274,7 @@
 
 do_plugin_build =				\
 	($(print_plugin_build)			\
-	$(CC) -shared -nostartfiles -o $@ $<)
+	$(CC) $(CFLAGS) $(LDFLAGS) -shared -nostartfiles -o $@ $<)
 
 do_build_static_lib =				\
 	($(print_static_lib_build)		\
@@ -221,28 +296,33 @@
 %.o: $(src)/%.c
 	$(Q)$(call check_gui)
 
-TRACE_CMD_OBJS = trace-cmd.o trace-usage.o trace-read.o trace-split.o trace-listen.o
-TRACE_VIEW_OBJS = trace-view.o trace-view-store.o trace-filter.o trace-compat.o \
-	trace-hash.o
-TRACE_GRAPH_OBJS = trace-graph.o trace-compat.o trace-hash.o trace-filter.o \
-		trace-plot.o trace-plot-cpu.o trace-plot-task.o
-TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS)
-TRACE_GRAPH_MAIN_OBJS = trace-graph-main.o $(TRACE_GRAPH_OBJS)
-KERNEL_SHARK_OBJS = $(TRACE_VIEW_OBJS) $(TRACE_GRAPH_OBJS) kernel-shark.o
-
-PEVENT_LIB_OBJS = parse-events.o trace-seq.o parse-filter.o
+TRACE_GUI_OBJS = trace-filter.o trace-compat.o trace-hash.o trace-dialog.o \
+		trace-xml.o
+TRACE_CMD_OBJS = trace-cmd.o trace-record.o trace-read.o trace-split.o trace-listen.o \
+	 trace-stack.o trace-options.o trace-hist.o trace-mem.o
+TRACE_VIEW_OBJS = trace-view.o trace-view-store.o
+TRACE_GRAPH_OBJS = trace-graph.o trace-plot.o trace-plot-cpu.o trace-plot-task.o
+TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS) $(TRACE_GUI_OBJS)
+TRACE_GRAPH_MAIN_OBJS = trace-graph-main.o $(TRACE_GRAPH_OBJS) $(TRACE_GUI_OBJS)
+KERNEL_SHARK_OBJS = $(TRACE_VIEW_OBJS) $(TRACE_GRAPH_OBJS) $(TRACE_GUI_OBJS) \
+	trace-capture.o kernel-shark.o
+
+PEVENT_LIB_OBJS = event-parse.o trace-seq.o parse-filter.o parse-utils.o
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
-			trace-output.o trace-record.o
+			trace-output.o trace-recorder.o trace-restore.o trace-usage.o \
+			trace-blk-hack.o kbuffer-parse.o
 
 PLUGIN_OBJS = plugin_hrtimer.o plugin_kmem.o plugin_sched_switch.o \
-	plugin_mac80211.o plugin_jbd2.o
+	plugin_mac80211.o plugin_jbd2.o plugin_function.o plugin_kvm.o \
+	plugin_blk.o
 
 PLUGINS := $(PLUGIN_OBJS:.o=.so)
 
 ALL_OBJS = $(TRACE_CMD_OBJS) $(KERNEL_SHARK_OBJS) $(TRACE_VIEW_MAIN_OBJS) \
 	$(TRACE_GRAPH_MAIN_OBJS) $(TCMD_LIB_OBJS) $(PLUGIN_OBJS)
 
-CMD_TARGETS = trace_plugin_dir tc_version.h libparsevent.a $(LIB_FILE) trace-cmd  $(PLUGINS)
+CMD_TARGETS = trace_plugin_dir trace_python_dir tc_version.h libparsevent.a $(LIB_FILE) \
+	trace-cmd  $(PLUGINS) $(BUILD_PYTHON)
 
 GUI_TARGETS = ks_version.h trace-graph trace-view kernelshark
 
@@ -336,8 +416,8 @@
 tc_version.h: force
 	$(Q)$(N)$(call update_version.h)
 
-define update_plugin_dir
-	(echo 'PLUGIN_DIR=$(PLUGIN_DIR)' > $@.tmp;	\
+define update_dir
+	(echo $1 > $@.tmp;	\
 	if [ -r $@ ] && cmp -s $@ $@.tmp; then		\
 		rm -f $@.tmp;				\
 	else						\
@@ -347,7 +427,10 @@
 endef
 
 trace_plugin_dir: force
-	$(Q)$(N)$(call update_plugin_dir)
+	$(Q)$(N)$(call update_dir, 'PLUGIN_DIR=$(PLUGIN_DIR)')
+
+trace_python_dir: force
+	$(Q)$(N)$(call update_dir, 'PYTHON_DIR=$(PYTHON_DIR)')
 
 ## make deps
 
@@ -379,97 +462,3 @@
 $(all_objs) : %.o : .%.d
 
 ifeq ($(BUILDGUI), 1)
-dep_includes := $(wildcard $(gui_deps))
-else
-dep_includes := $(wildcard $(non_gui_deps))
-endif
-
-ifneq ($(dep_includes),)
- include $(dep_includes)
-endif
-
-show_gui_make:
-	@echo "Note: to build the gui, type \"make gui\""
-
-show_gui_done:
-	@echo "gui build complete"
-
-PHONY += show_gui_make
-
-tags:	force
-	$(RM) tags
-	find . -name '*.[ch]' | xargs ctags
-
-TAGS:	force
-	$(RM) TAGS
-	find . -name '*.[ch]' | xargs etags
-
-PLUGINS_INSTALL = $(subst .so,.install,$(PLUGINS))
-
-define do_install
-	$(print_install)				\
-	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
-		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
-	fi;						\
-	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
-endef
-
-$(PLUGINS_INSTALL): %.install : %.so force
-	$(Q)$(call do_install,$<,$(plugin_dir_SQ))
-
-install_plugins: $(PLUGINS_INSTALL)
-
-install_cmd: all_cmd install_plugins
-	$(Q)$(call do_install,trace-cmd,$(bindir_SQ))
-
-install: install_cmd
-	@echo "Note: to install the gui, type \"make install_gui\""
-
-install_gui: install_cmd gui
-	$(Q)$(call do_install,trace-view,$(bindir_SQ))
-	$(Q)$(call do_install,trace-graph,$(bindir_SQ))
-	$(Q)$(call do_install,kernelshark,$(bindir_SQ))
-
-doc:
-	$(MAKE) -C $(src)/Documentation all
-
-doc_clean:
-	$(MAKE) -C $(src)/Documentation clean
-
-install_doc:
-	$(MAKE) -C $(src)/Documentation install
-
-clean:
-	$(RM) *.o *~ $(TARGETS) *.a *.so ctracecmd_wrap.c .*.d
-	$(RM) tags TAGS trace_plugin_dir
-
-
-##### PYTHON STUFF #####
-
-PYTHON_INCLUDES = `python-config --includes`
-PYGTK_CFLAGS = `pkg-config --cflags pygtk-2.0`
-
-ctracecmd.so: $(TCMD_LIB_OBJS)
-	swig -Wall -python -noproxy ctracecmd.i
-	gcc -fpic -c $(PYTHON_INCLUDES)  ctracecmd_wrap.c
-	$(CC) --shared $^ ctracecmd_wrap.o -o ctracecmd.so
-
-ctracecmdgui.so: $(TRACE_VIEW_OBJS) $(LIB_FILE)
-	swig -Wall -python -noproxy ctracecmdgui.i
-	gcc -fpic -c  $(CFLAGS) $(INCLUDES) $(PYTHON_INCLUDES) $(PYGTK_CFLAGS) ctracecmdgui_wrap.c
-	$(CC) --shared $^ $(LIBS) $(CONFIG_LIBS) ctracecmdgui_wrap.o -o ctracecmdgui.so
-
-PHONY += python
-python: ctracecmd.so
-
-PHONY += python-gui
-python-gui: ctracecmd.so ctracecmdgui.so 
-
-endif # skip-makefile
-
-PHONY += force
-force:
-
-# Declare the contents of the .PHONY variable as phony.  We keep that
-# information in a variable so we can use it in if_changed and friends.
-.PHONY: $(PHONY)

=== Documentation/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 define manpage.xsl
-	if [ ! -f ${MANPAGE_DOCBOOK_XSL} ]; then 		\
+	if [ -z ${MANPAGE_DOCBOOK_XSL} ]; then 			\
 		echo "*********************************";	\
 		echo "** No docbook.xsl is installed **";	\
 		echo "** Can't make man pages        **";	\
@@ -46,7 +46,7 @@
 # Most likely a docbook.xsl is already installed on the users system
 # instead of creating a new wheel, lets reuse what's already there.
 #
-MANPAGE_DOCBOOK_XSL =  $(shell locate manpages/docbook.xsl | head -1)
+MANPAGE_DOCBOOK_XSL ?=  $(shell locate manpages/docbook.xsl | head -1)
 
 $(obj)/%.xsl: $(src)/%.txt
 	$(Q)mkdir -p $(obj)
@@ -87,7 +87,25 @@
 $(MAN5_INSTALL): %.5.install : %.5 force
 	$(Q)$(call do_install,$<,$(man_dir_SQ)/man5)
 
-install: $(MAN1_INSTALL) $(MAN5_INSTALL)
+html_dir = $(src)/HTML
+image_dir = $(html_dir)/images
+
+HTML = $(wildcard $(html_dir)/*.html)
+IMGS = $(wildcard $(image_dir)/*.png)
+
+HTML_INSTALL = $(subst .html,.html.install,$(HTML))
+IMGS_INSTALL = $(subst .png,.png.install,$(IMGS))
+
+$(HTML_INSTALL): %.html.install : %.html force
+	$(Q)$(call do_install,$<,'$(html_install_SQ)')
+
+$(IMGS_INSTALL): %.png.install : %.png force
+	$(Q)$(call do_install,$<,'$(img_install_SQ)')
+
+
+GUI_INSTALL = $(HTML_INSTALL) $(IMGS_INSTALL)
+
+install: $(MAN1_INSTALL) $(MAN5_INSTALL) $(GUI_INSTALL)
 
 clean:
 	(cd $(obj); \

## trace-cmd 2.3.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # trace-cmd version
 TC_VERSION = 2
-TC_PATCHLEVEL = 2
+TC_PATCHLEVEL = 3
 TC_EXTRAVERSION = 1
 
 # Kernel Shark version
@@ -47,6 +47,7 @@
 html_install_SQ = '$(subst ','\'',$(html_install))'
 img_install = $(prefix)/share/kernelshark/html/images
 img_install_SQ = '$(subst ','\'',$(img_install))'
+libdir ?= lib
 
 export man_dir man_dir_SQ html_install html_install_SQ INSTALL
 export img_install img_install_SQ
@@ -56,8 +57,8 @@
 plugin_dir = $(HOME)/.trace-cmd/plugins
 python_dir = $(HOME)/.trace-cmd/python
 else
-plugin_dir = $(prefix)/lib/trace-cmd/plugins
-python_dir = $(prefix)/lib/trace-cmd/python
+plugin_dir = $(prefix)/$(libdir)/trace-cmd/plugins
+python_dir = $(prefix)/$(libdir)/trace-cmd/python
 PLUGIN_DIR = -DPLUGIN_DIR="$(plugin_dir)"
 PYTHON_DIR = -DPYTHON_DIR="$(python_dir)"
 PLUGIN_DIR_SQ = '$(subst ','\'',$(PLUGIN_DIR))'
@@ -80,12 +81,15 @@
 PYTHON		:= ctracecmd.so
 PYTHON_GUI	:= ctracecmd.so ctracecmdgui.so
 
+PYTHON_VERS ?= python
+
 # Can build python?
-ifeq ($(shell sh -c "python-config --includes > /dev/null 2>&1 && echo y"), y)
+ifeq ($(shell sh -c "pkg-config --cflags $(PYTHON_VERS) > /dev/null 2>&1 && echo y"), y)
 	PYTHON_PLUGINS := plugin_python.so
 	BUILD_PYTHON := $(PYTHON) $(PYTHON_PLUGINS)
 	PYTHON_SO_INSTALL := ctracecmd.install
-	PYTHON_PY_INSTALL := event-viewer.install tracecmd.install tracecmdgui.install
+	PYTHON_PY_PROGS := event-viewer.install
+	PYTHON_PY_LIBS := tracecmd.install tracecmdgui.install
 endif
 endif # NO_PYTHON
 
@@ -214,11 +218,15 @@
 
 INCLUDES = -I. $(CONFIG_INCLUDES)
 
-include features.mk
+include $(src)/features.mk
 
 # Set compile option CFLAGS if not set elsewhere
-CFLAGS ?= -g -Wall -D_GNU_SOURCE
+CFLAGS ?= -g -Wall
+CPPFLAGS ?=
 LDFLAGS ?=
+
+# Required CFLAGS
+override CFLAGS += -D_GNU_SOURCE
 
 ifndef NO_PTRACE
 ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
@@ -258,7 +266,7 @@
 
 do_fpic_compile =					\
 	($(print_fpic_compile)				\
-	$(CC) -c $(CFLAGS) $(EXT) -fPIC $< -o $@)
+	$(CC) -c $(CPPFLAGS) $(CFLAGS) $(EXT) -fPIC $< -o $@)
 
 do_app_build =						\
 	($(print_app_build)				\
@@ -270,7 +278,7 @@
 
 do_compile_plugin_obj =				\
 	($(print_plugin_obj_compile)		\
-	$(CC) -c $(CFLAGS) -fPIC -o $@ $<)
+	$(CC) -c $(CPPFLAGS) $(CFLAGS) -fPIC -o $@ $<)
 
 do_plugin_build =				\
 	($(print_plugin_build)			\
@@ -286,7 +294,7 @@
 		$(REBUILD_GUI);							\
 	else									\
 		$(print_compile)						\
-		$(CC) -c $(CFLAGS) $(EXT) $< -o $(obj)/$@;			\
+		$(CC) -c $(CPPFLAGS) $(CFLAGS) $(EXT) $< -o $(obj)/$@;		\
 	fi;
 endef
 
@@ -299,7 +307,7 @@
 TRACE_GUI_OBJS = trace-filter.o trace-compat.o trace-hash.o trace-dialog.o \
 		trace-xml.o
 TRACE_CMD_OBJS = trace-cmd.o trace-record.o trace-read.o trace-split.o trace-listen.o \
-	 trace-stack.o trace-options.o trace-hist.o trace-mem.o
+	 trace-stack.o trace-hist.o trace-mem.o trace-snapshot.o
 TRACE_VIEW_OBJS = trace-view.o trace-view-store.o
 TRACE_GRAPH_OBJS = trace-graph.o trace-plot.o trace-plot-cpu.o trace-plot-task.o
 TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS) $(TRACE_GUI_OBJS)
@@ -312,9 +320,16 @@
 			trace-output.o trace-recorder.o trace-restore.o trace-usage.o \
 			trace-blk-hack.o kbuffer-parse.o
 
-PLUGIN_OBJS = plugin_hrtimer.o plugin_kmem.o plugin_sched_switch.o \
-	plugin_mac80211.o plugin_jbd2.o plugin_function.o plugin_kvm.o \
-	plugin_blk.o
+PLUGIN_OBJS =
+PLUGIN_OBJS += plugin_hrtimer.o
+PLUGIN_OBJS += plugin_kmem.o
+PLUGIN_OBJS += plugin_sched_switch.o
+PLUGIN_OBJS += plugin_mac80211.o
+PLUGIN_OBJS += plugin_jbd2.o
+PLUGIN_OBJS += plugin_function.o
+PLUGIN_OBJS += plugin_kvm.o
+PLUGIN_OBJS += plugin_blk.o
+PLUGIN_OBJS += plugin_cfg80211.o
 
 PLUGINS := $(PLUGIN_OBJS:.o=.so)
 
@@ -444,21 +459,4 @@
 		if [ $(BUILDGUI) -ne 1 ]; then			\
 			$(REBUILD_GUI);				\
 		else						\
-			$(CC) -M $(CFLAGS) $< > $@;		\
-		fi						\
-	elif [ $(BUILDGUI) -eq 0 ]; then			\
-		$(CC) -M $(CFLAGS) $< > $@;			\
-	else							\
-		echo SKIPPING $@;				\
-	fi;
-endef
-
-$(gui_deps): ks_version.h
-$(non_gui_deps): tc_version.h
-
-$(all_deps): .%.d: $(src)/%.c
-	$(Q)$(call check_gui_deps)
-
-$(all_objs) : %.o : .%.d
-
-ifeq ($(BUILDGUI), 1)
+			$(CC) -M $(CPPFLAGS) $(CFLAGS) $< > $@;	\

=== debian/changelog ===
trace-cmd (2.3.1-1) unstable; urgency=medium

  * Update to upstream 2.3.1 release

 -- Seth Forshee <seth.forshee@canonical.com>  Tue, 28 Jan 2014 09:35:24 +0000

trace-cmd (2.3.0-1) unstable; urgency=low

  * Update to 2.3.0 release
  * Remove all patches as they have been incorported into the new
    upstream release

 -- Seth Forshee <seth.forshee@canonical.com>  Mon, 06 Jan 2014 14:58:48 -0600

trace-cmd (2.2.1-2) unstable; urgency=low

  * debian/patches/0001-trace-cmd-Make-_GNU_SOURCE-always-defined.patch:
    Use this upstream fix instead of
    debian/patches/0001-trace-cmd-listen-Remove-use-of-sighandler_t.patch
  * debian/patches/0006-Makefile-Ensure-_GNU_SOURCE-really-is-always-defined.patch:
    Ensure _GNU_SOURCE is set in the case of CFLAGS being provided via a
    command argument
  * Change architecture to linux-any as this package won't work with
    any other kernels.
  * Bump Standards-Version to 3.9.5
  * debian/patches/0007-Makefile-Use-CPPFLAGS-from-the-environment.patch:
    Use CPPFLAGS from the environment

 -- Seth Forshee <seth.forshee@canonical.com>  Fri, 13 Dec 2013 20:08:28 -0600

trace-cmd (2.2.1-1) unstable; urgency=low

  * Update to 2.2.1 upstream release
  * debian/patches/0001-trace-cmd-listen-Remove-use-of-sighandler_t.patch:
    Fix build error due to sigaction_t being undefined
  * 0002-build-Install-data-files-without-execute-permissions.patch: Fix
    lintian executable-not-elf-or-script warnings
  * debian/patches/0003-Add-missing-libgen.h-includes.patch: Fix segfaults
    caused by missing libgen.h includes
  * debian/patches/0004-Documentation-Add-kernelshark.1.txt.patch: Add man
    page for kernelshark
  * Update kernelshark.install to include kernelshark docs 
  * debian/patches/0005-Makefile-Use-CFLAGS-and-LDFLAGS-when-building-python.patch:
    Fix lintian hardening-no-relro warnings 
  * Bump standards version to 3.9.4
  * Add myself and Kamal Mostafa as uploaders
  * First Debian release (Closes: #691502)

 -- Seth Forshee <seth.forshee@canonical.com>  Wed, 23 Oct 2013 11:11:32 -0500

trace-cmd (1.0.3-0ubuntu2) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:28:42 -0700

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,24 @@
 Section: devel
 Priority: optional
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
-Standards-Version: 3.8.4.0
-Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc
+Uploaders: Seth Forshee <seth.forshee@canonical.com>, Kamal Mostafa <kamal@canonical.com>
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
 Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git
 
 Package: trace-cmd
-Architecture: any
+Architecture: linux-any
 Section: devel
 Priority: optional
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python
 Suggests: kernelshark
 Description: Utility for retrieving and analyzing function tracing in the kernel
  This package contains the trace-cmd utility. Trace-cmd makes it easy to
  retrieve and analyze function traces from the Linux kernel while it is running.
 
 Package: kernelshark
-Architecture: any
+Architecture: linux-any
 Section: devel
 Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}

## trace-cmd 2.4.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
 TC_VERSION = 2
-TC_PATCHLEVEL = 3
-TC_EXTRAVERSION = 1
+TC_PATCHLEVEL = 4
+TC_EXTRAVERSION = 0
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -216,7 +216,7 @@
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 KERNELSHARK_VERSION = $(KS_VERSION).$(KS_PATCHLEVEL).$(KS_EXTRAVERSION)
 
-INCLUDES = -I. $(CONFIG_INCLUDES)
+INCLUDES = -I. -I $(srctree)/../../include $(CONFIG_INCLUDES)
 
 include $(src)/features.mk
 
@@ -318,18 +318,20 @@
 PEVENT_LIB_OBJS = event-parse.o trace-seq.o parse-filter.o parse-utils.o
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
 			trace-output.o trace-recorder.o trace-restore.o trace-usage.o \
-			trace-blk-hack.o kbuffer-parse.o
+			trace-blk-hack.o kbuffer-parse.o event-plugin.o
 
 PLUGIN_OBJS =
+PLUGIN_OBJS += plugin_jbd2.o
 PLUGIN_OBJS += plugin_hrtimer.o
 PLUGIN_OBJS += plugin_kmem.o
+PLUGIN_OBJS += plugin_kvm.o
+PLUGIN_OBJS += plugin_mac80211.o
 PLUGIN_OBJS += plugin_sched_switch.o
-PLUGIN_OBJS += plugin_mac80211.o
-PLUGIN_OBJS += plugin_jbd2.o
 PLUGIN_OBJS += plugin_function.o
-PLUGIN_OBJS += plugin_kvm.o
+PLUGIN_OBJS += plugin_xen.o
+PLUGIN_OBJS += plugin_scsi.o
+PLUGIN_OBJS += plugin_cfg80211.o
 PLUGIN_OBJS += plugin_blk.o
-PLUGIN_OBJS += plugin_cfg80211.o
 
 PLUGINS := $(PLUGIN_OBJS:.o=.so)
 
@@ -456,7 +458,3 @@
 
 define check_gui_deps
 	if [ ! -z "$(filter $(gui_deps),$(@))" ];	then	\
-		if [ $(BUILDGUI) -ne 1 ]; then			\
-			$(REBUILD_GUI);				\
-		else						\
-			$(CC) -M $(CPPFLAGS) $(CFLAGS) $< > $@;	\

=== debian/changelog ===
trace-cmd (2.4.0-1) unstable; urgency=medium

  * Update to upstream 2.4 release
  * debian/patches/0001-trace-cmd-Add-missing-mode-to-open-call.patch:
    Fix error caused by missing mode argument to open(2) with O_CREAT
  * debian/patches/0002-trace-cmd-Use-python2.7-for-executable-name.patch:
    Workaround for lintian python-script-but-no-python-dep error

 -- Seth Forshee <seth.forshee@canonical.com>  Thu, 19 Jun 2014 15:34:11 -0500

trace-cmd (2.3.2-1) unstable; urgency=medium

  * Update to upstream 2.3.2 release

 -- Seth Forshee <seth.forshee@canonical.com>  Mon, 10 Mar 2014 06:40:43 -0500

## trace-cmd 2.5.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
 TC_VERSION = 2
-TC_PATCHLEVEL = 4
-TC_EXTRAVERSION = 0
+TC_PATCHLEVEL = 5
+TC_EXTRAVERSION = 1
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -304,10 +304,11 @@
 %.o: $(src)/%.c
 	$(Q)$(call check_gui)
 
-TRACE_GUI_OBJS = trace-filter.o trace-compat.o trace-hash.o trace-dialog.o \
+TRACE_GUI_OBJS = trace-filter.o trace-compat.o trace-filter-hash.o trace-dialog.o \
 		trace-xml.o
 TRACE_CMD_OBJS = trace-cmd.o trace-record.o trace-read.o trace-split.o trace-listen.o \
-	 trace-stack.o trace-hist.o trace-mem.o trace-snapshot.o
+	 trace-stack.o trace-hist.o trace-mem.o trace-snapshot.o trace-stat.o \
+	 trace-hash.o trace-profile.o trace-stream.o
 TRACE_VIEW_OBJS = trace-view.o trace-view-store.o
 TRACE_GRAPH_OBJS = trace-graph.o trace-plot.o trace-plot-cpu.o trace-plot-task.o
 TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS) $(TRACE_GUI_OBJS)
@@ -317,8 +318,9 @@
 
 PEVENT_LIB_OBJS = event-parse.o trace-seq.o parse-filter.o parse-utils.o
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
-			trace-output.o trace-recorder.o trace-restore.o trace-usage.o \
-			trace-blk-hack.o kbuffer-parse.o event-plugin.o
+			trace-output.o trace-record.o trace-recorder.o \
+			trace-restore.o trace-usage.o trace-blk-hack.o \
+			kbuffer-parse.o event-plugin.o
 
 PLUGIN_OBJS =
 PLUGIN_OBJS += plugin_jbd2.o
@@ -456,5 +458,3 @@
 gui_deps := $(gui_objs:%.o=.%.d)
 non_gui_deps = $(filter-out $(gui_deps),$(all_deps))
 
-define check_gui_deps
-	if [ ! -z "$(filter $(gui_deps),$(@))" ];	then	\

=== debian/changelog ===
trace-cmd (2.5.1-1) unstable; urgency=medium

  * Update to upstream 2.5.1 release
  * Drop 0001-trace-cmd-Add-missing-mode-to-open-call.patch as it is
    included in the new upstream release

 -- Seth Forshee <seth.forshee@canonical.com>  Thu, 05 Feb 2015 08:19:04 -0600

## trace-cmd 2.5.3

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
 TC_VERSION = 2
 TC_PATCHLEVEL = 5
-TC_EXTRAVERSION = 1
+TC_EXTRAVERSION = 3
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -320,7 +320,7 @@
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
 			trace-output.o trace-record.o trace-recorder.o \
 			trace-restore.o trace-usage.o trace-blk-hack.o \
-			kbuffer-parse.o event-plugin.o
+			kbuffer-parse.o event-plugin.o trace-hooks.o
 
 PLUGIN_OBJS =
 PLUGIN_OBJS += plugin_jbd2.o
@@ -456,5 +456,3 @@
 all_objs := $(sort $(ALL_OBJS))
 all_deps := $(all_objs:%.o=.%.d)
 gui_deps := $(gui_objs:%.o=.%.d)
-non_gui_deps = $(filter-out $(gui_deps),$(all_deps))
-

=== debian/changelog ===
trace-cmd (2.5.3-1) unstable; urgency=medium

  * Bump Standards-Version to 3.9.6
  * Update to upstream 2.5.3 release

 -- Seth Forshee <seth.forshee@canonical.com>  Mon, 09 Mar 2015 09:30:02 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
 Uploaders: Seth Forshee <seth.forshee@canonical.com>, Kamal Mostafa <kamal@canonical.com>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
 Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git

## trace-cmd 2.6

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
 TC_VERSION = 2
-TC_PATCHLEVEL = 5
-TC_EXTRAVERSION = 3
+TC_PATCHLEVEL = 6
+TC_EXTRAVERSION =
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -231,12 +231,25 @@
 ifndef NO_PTRACE
 ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
 	NO_PTRACE = 1
-	CFLAGS += -DWARN_NO_PTRACE
+	override CFLAGS += -DWARN_NO_PTRACE
 endif
 endif
 
 ifdef NO_PTRACE
-CFLAGS += -DNO_PTRACE
+override CFLAGS += -DNO_PTRACE
+endif
+
+ifndef NO_AUDIT
+ifneq ($(call try-cc,$(SOURCE_AUDIT),-laudit),y)
+	NO_AUDIT = 1
+	override CFLAGS += -DWARN_NO_AUDIT
+endif
+endif
+
+ifdef NO_AUDIT
+override CFLAGS += -DNO_AUDIT
+else
+LIBS += -laudit
 endif
 
 # Append required CFLAGS
@@ -334,6 +347,7 @@
 PLUGIN_OBJS += plugin_scsi.o
 PLUGIN_OBJS += plugin_cfg80211.o
 PLUGIN_OBJS += plugin_blk.o
+PLUGIN_OBJS += plugin_tlb.o
 
 PLUGINS := $(PLUGIN_OBJS:.o=.so)
 
@@ -446,13 +460,3 @@
 endef
 
 trace_plugin_dir: force
-	$(Q)$(N)$(call update_dir, 'PLUGIN_DIR=$(PLUGIN_DIR)')
-
-trace_python_dir: force
-	$(Q)$(N)$(call update_dir, 'PYTHON_DIR=$(PYTHON_DIR)')
-
-## make deps
-
-all_objs := $(sort $(ALL_OBJS))
-all_deps := $(all_objs:%.o=.%.d)
-gui_deps := $(gui_objs:%.o=.%.d)

=== debian/changelog ===
trace-cmd (2.6-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release
  * Build-depend on dh-python
  * Bump standards-version to 3.9.8 (no change needed)

 -- Javi Merino <vicho@debian.org>  Sun, 17 Jul 2016 13:40:44 +0100

## trace-cmd 2.6.1

=== debian/changelog ===
trace-cmd (2.6.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update to v2.6.1:
    Fixs segfault while processing certain trace files (Closes: #867440).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 12 Sep 2017 21:50:27 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
 Uploaders: Seth Forshee <seth.forshee@canonical.com>, Kamal Mostafa <kamal@canonical.com>
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig
+Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig, dh-python
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
 Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,6 @@
 DEB_MAKE_CLEAN_TARGET=clean doc_clean $(OPTS)
 DEB_MAKE_BUILD_TARGET=gui doc $(OPTS)
 DEB_MAKE_INSTALL_TARGET=install_gui install_doc $(OPTS)
+
+binary-install/trace-cmd::
+	dh_python2 -ptrace-cmd /usr/lib/trace-cmd/python
